<?php

namespace FiloBlu\Newsletter\Model;

use Magento\Framework\Exception\LocalizedException as CoreException;

class LandingPage extends \Magento\Framework\Model\AbstractModel {

    protected $landingPageCollectionFactory;

    /**
     * Store manager
     *
     * @var \Magento\Store\Model\StoreManagerInterface
     */
    protected $_storeManager;
    
//    protected $thankYouPageCollectionFactory;
//    
//    protected $preConfirmPageCollectionFactory;

    public function __construct(
    \FiloBlu\Newsletter\Model\ResourceModel\LandingPage\CollectionFactory $landingPageCollectionFactory, 
            \Magento\Store\Model\StoreManagerInterface $_storeManager,
            \Magento\Framework\Model\Context $context, 
            \Magento\Framework\Registry $registry,
            \Magento\Framework\Model\ResourceModel\AbstractResource $resource = null,
            \Magento\Framework\Data\Collection\AbstractDb $resourceCollection = null,
            array $data = []
//            \FiloBlu\Newsletter\Model\ResourceModel\PreConfirm\CollectionFactory $preConfirmPageCollectionFactory,
//            \FiloBlu\Newsletter\Model\ResourceModel\ThankYou\CollectionFactory $thankYouPageCollectionFactory
    ) {
        $this->landingPageCollectionFactory = $landingPageCollectionFactory;
//        $this->thankYouPageCollectionFactory = $thankYouPageCollectionFactory;
//        $this->preConfirmPageCollectionFactory = $preConfirmPageCollectionFactory;
        $this->_storeManager = $_storeManager;
        parent::__construct($context, $registry, $resource, $resourceCollection, $data);
    }

    /**
     * Initialize resource model
     *
     * @return void
     */
    protected function _construct() {
        $this->_init('FiloBlu\Newsletter\Model\ResourceModel\LandingPage');
    }

    public function getAvailableStatuses() {
        return array(
            0 => "Disabled",
            1 => "Enabled"
        );
    }
//    public function getAvailablePreConfirm() {
//        
//        $collection = $this->preConfirmPageCollectionFactory->create();
//        $collection->addFieldToSelect(array('preconfirm_id','title'));
//        
//        $array = [];
//        foreach ($collection->getData() as $value) {
//            $array[$value["preconfirm_id"]] = $value["label"];
//        }
//        
//        return $array;
//    }
//    public function getAvailableThankYou() {
//        $collection = $this->thankYouPageCollectionFactory->create();
//        $collection->addFieldToSelect(array('thankyou_id','title'));
//        
//        $array = [];
//        foreach ($collection->getData() as $value) {
//            $array[$value["thankyou_id"]] = $value["label"];
//        }
//        
//        return $array;
//    }

    public function beforeSave() {
        if (is_array($this->getData('store_ids'))) {
            $this->setData('store_ids', implode(',', $this->getData('store_ids')));
        }
        return parent::beforeSave();
    }

    public function getAllLandingPage() {
        $collection = $this->landingPageCollectionFactory->create();
        $collection->addFieldToFilter('enabled', ["eq" => 1]);
        $collection->addStoreFilter($this->_storeManager->getStore()->getId());

        return $collection;
    }

    public function getAllUrlLandingPage() {
        $collection = $this->getAllLandingPage();
        $collection->addFieldToSelect(array('url_key'));

        return $collection;
    }

    public function getLandingPageById($id) {
        $collection = $this->getAllLandingPage();
        $collection->addFieldToFilter('landing_id', ["eq" => $id]);
        
        return $collection->getFirstItem();
    }

}
